// ----------------------------------------------------------------------------
//
//			73322 Tset Code
//
//		Interrupt Service Routines
//
//				Nov 7 / 02
//
// ---------------------------------------------------------------------------- 


#include <def21535.h>
#include <SportBits.h>

// ----------------------------------------------------------------------------
//	Global and External Declarations

.global		_EHANDLER;
.global		_RHANDLER;
.global		_NHANDLER;
.global		_XHANDLER;
.global		_HWHANDLER;
.global		_THANDLER;
.global		_RTCHANDLER;
.global		_SportISR;
.global		_I9HANDLER;
.global		_I10HANDLER;
.global		_I11HANDLER;
.global		_I12HANDLER;
.global		_I13HANDLER;
.global		_I14HANDLER;
.global		_I15HANDLER;

// ----------------------------------------------------------------------------
//	Sport1 TX ISR
.Section ISRCode;

_SportISR:
		[--SP] = (r7:0);
		[--SP] = (p5:0);
		
		LoadP0(SIC_ISR)						// read MMR to determine what caused the interrupt
		R0 = [P0];
		cc = bittst (R0, 4);
		if cc jump SportRxISR;

// ----------------------------------------------------------------------------
//	Sport1 Tx ISR
		
SportTxISR:		
		cc = bittst (R7, 0);				// test flag
		if !CC jump int5_done;				// if set
		bitset (R7,0);

		(p5:0) = [SP++];  					// Restore Regs
		(r7:0) = [SP++];
		rti;
		
int5_done:
		LoadP0(SIC_IMASK)
		R0 = w[P0];
		bitset (R0,7);						// Use to be "bitclr"..Errata #8, SIC_IMASK inversion
		w[P0] = R0; ssync;
		R7 = 0;

		(p5:0) = [SP++];  					// Restore Regs
		(r7:0) = [SP++];
		rti;
		
// ----------------------------------------------------------------------------
//	Sport1 Rx ISR

SportRxISR:	
//		R0 = 0x0C0;							// old=0x0C0, Errata #8
		R0.h = 0xFFFF;						// enables Sport1 IRQs, old =0x000000C0, Errata #8
		R0.l = 0xFF3F;
		LoadP0(SIC_IMASK)					
		w[P0] = R0; ssync;
		
		(p5:0) = [SP++];  					// Restore Regs
		(r7:0) = [SP++];
		rti;
		
		
_EHANDLER:            // Emulation Handler 0
    RTE;

_RHANDLER:            // Reset Handler 1
    RTI;

_NHANDLER:            // NMI Handler 2
	RTN;

_XHANDLER:            // Exception Handler 3
    RTX;

_HWHANDLER:           // HW Error Handler 5
    RTI;

_THANDLER:            // Timer Handler 6
	RTI;

_RTCHANDLER:           // IVG 7 Handler  (RTC)
	RTI;
		
_I9HANDLER:           // IVG 9 Handler
    RTI;

_I10HANDLER:          // IVG 10 Handler
    RTI;

_I11HANDLER:          // IVG 11 Handler
    RTI;

_I12HANDLER:          // IVG 12 Handler
    RTI;

_I13HANDLER:		// IVG 13 Handler
    RTI;

_I14HANDLER:
    RTI;

_I15HANDLER:
	nop;
	nop;
	nop;
	nop;
    RTI;
		
