/* ---------------------------------------------------------------------------- */
/*			73322 Test Code			*/
/*									*/
/*		PF10 - Reset				*/
/*		PF11 - SE					*/
/*									*/
/*		2 CODECs wired in cascade	*/ 
/* ---------------------------------------------------------------------------- */

#include <def21535.h>
#include <SportBits.h>

/* ---------------------------------------------------------------------------- */		
/* Global and External Declarations	*/

.GLOBAL 	Start;

.EXTERN		_EHANDLER;
.EXTERN		_RHANDLER;
.EXTERN		_NHANDLER;
.EXTERN		_XHANDLER;
.EXTERN		_HWHANDLER;
.EXTERN		_THANDLER;
.EXTERN		_RTCHANDLER;
.EXTERN		_SportISR;
.EXTERN		_I9HANDLER;
.EXTERN		_I10HANDLER;
.EXTERN		_I11HANDLER;
.EXTERN		_I12HANDLER;
.EXTERN		_I13HANDLER;
.EXTERN		_I14HANDLER;
.EXTERN		_I15HANDLER;

/* ---------------------------------------------------------------------------- */		
/* Data Memory						*/

.SECTION Buffers;

.byte2	TxBuf[18] = 				// for 1 device

		/*5432109876543210*/
		b#1000100100000110,			// CRB - DmClk=MCLK=10MHz, SCLK=MCLK, Fs= DMCLK/256=39.0625KHz
		b#1000000100000110,			// CRB - DmClk=MCLK=10MHz, SCLK=MCLK, Fs= DMCLK/256=39.0625KHz
		
		b#1000101000111101,			// CRC - RefOut=Disabled, Ref Power=On,InAmp=Off, Gain Tap=Off
		b#1000001000111101,			// CRC - RefOut=Disabled, Ref Power=On,InAmp=Off, Gain Tap=Off
		
		b#1000101100000000,			// CRD - I/O gain=0, ADC Mod=Off, Mute=Off
		b#1000001100000000,			// CRD - I/O gain=0, ADC Mod=Off, Mute=Off
		
		b#1000110000000000,			// CRE - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		b#1000010000000000,			// CRE - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		
		b#1000110100000000,			// CRF - A Gain Tap=0, Single Ended, A Gain Tap=Disables, 
		b#1000010000000000,			// CRF - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		
		b#1000111000000000,			// CRG - Digital Gain Tap Coef0-7=0
		b#1000011000000000,			// CRG - Digital Gain Tap Coef0-7=0
		
		b#1000111100000000,			// CRH - Digital Gain Tap Coef8-15=0
		b#1000011100000000,			// CRH - Digital Gain Tap Coef8-15=0
		
//        5432109876543210 
		b#1000100000010000,			// CRA - Program Mode, Mixed Mode=Off, Dig/SPORT LoopBack=0, Device Count=1
		b#1000000000010000,			// CRA - Program Mode, Mixed Mode=Off, Dog/SPORT LoopBack=0, Device Count=1
				
		b#1000100000010001,			// CRA - Data Mode, Mixed Mode=Off, LoopBack=0, Device Count=1
		b#1000000000010001;			// CRA - Data Mode, Mixed Mode=Off, LoopBack=0, Device Count=1
		


.byte2	TxBuf4[32] = 				// for 2 devices

		/*5432109876543210*/
		b#1001100100001111,			// CRB - DmClk=MCLK=10MHz, SCLK=MCLK, Fs= DMCLK/256=39.0625KHz
		b#1001000100001111,			// CRB - DmClk=MCLK=10MHz, SCLK=MCLK, Fs= DMCLK/256=39.0625KHz
		b#1000100100001111,			// CRB - DmClk=MCLK=10MHz, SCLK=MCLK, Fs= DMCLK/256=39.0625KHz
		b#1000000100001111,			// CRB - DmClk=MCLK=10MHz, SCLK=MCLK, Fs= DMCLK/256=39.0625KHz
		
		b#1001101000100001,			// CRC - RefOut=Disabled, Ref Power=On,InAmp=Off, Gain Tap=Off
		b#1001001000100001,			// CRC - ditto
		b#1000101000100001,			// CRC - RefOut=Disabled, Ref Power=On,InAmp=Off, Gain Tap=Off
		b#1000001000100001,			// CRC - ditto
		
		b#1001101100000000,			// CRD - I/O gain=0, ADC Mod=Off, Mute=Off
		b#1001001100000000,			// CRD - ditto
		b#1000101100000000,			// CRD - I/O gain=0, ADC Mod=Off, Mute=Off
		b#1000001100000000,			// CRD - ditto
		
		b#1001110000000000,			// CRE - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		b#1001010000000000,			// CRE - ditto
		b#1000110000000000,			// CRE - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		b#1000010000000000,			// CRE - ditto
		
		b#1001110100000000,			// CRF - A Gain Tap=0, Single Ended, A Gain Tap=Disables, 
		b#1001010100000000,			// CRF - Input not inverted, LoopBack=Disabled, A Gain Tap Muted
		b#1000110100000000,			// CRF - A Gain Tap=0, Single Ended, A Gain Tap=Disables, 
		b#1000010100000000,			// CRF - Input not inverted, LoopBack=Disabled, A Gain Tap Muted
		
		b#1001111000000000,			// CRG - Digital Gain Tap Coef0-7=0
		b#1001011000000000,			// CRG - ditto
		b#1000111000000000,			// CRG - Digital Gain Tap Coef0-7=0
		b#1000011000000000,			// CRG - ditto
		
		b#1001111100000000,			// CRH - Digital Gain Tap Coef8-15=0
		b#1001011100000000,			// CRH - ditto
		b#1000111100000000,			// CRH - Digital Gain Tap Coef8-15=0
		b#1000011100000000,			// CRH - ditto
		
		b#1001100000110001,			// CRA - Data Mode, Mixed Mode=Off, LoopBack=0, Device Count=1
		b#1001000000110001,			// CRA - Reset=Off
		b#1000100000110001,			// CRA - Data Mode, Mixed Mode=Off, LoopBack=0, Device Count=1
		b#1000000000110001;			// CRA - Reset=Off
		

#define RxBufLen	12000

.var	RxBuf[RxBufLen];

/* ---------------------------------------------------------------------------- */		
//	Code Start.....
.Section ProgramCode;


// Setup Event Vectors and Handlers

SETUP:	R0 = 0;
		LoadP0(EVT0)
		r1 = _EHANDLER (Z);
		r1.h = _EHANDLER;  				// Emulation Handler (Int0)
      	[ P0 ++ ] = R1;

	    R0 = _RHANDLER (Z);
	    R0.H = _RHANDLER;  				// Reset Handler (Int1)
	    [ P0 ++ ] = R0;

    	R0 = _NHANDLER (Z);
		R0.H = _NHANDLER;  				// NMI Handler (Int2)
		[ P0 ++ ] = R0;

	    R0.L = _XHANDLER;
	  	R0.H = _XHANDLER;  				// Exception Handler (Int3)
		[ P0 ++ ] = R0;
	
		[ P0 ++ ] = R0; 				// IVT4 isn't used

		R0 = _HWHANDLER (Z);
		R0.H = _HWHANDLER; 				// HW Error Handler (Int5)
		[ P0 ++ ] = R0;
	
      	R0 = _THANDLER (Z);
		R0.H = _THANDLER;  				// Timer Handler (Int6)
		[ P0 ++ ] = R0;
	
  	    R0 = _RTCHANDLER (Z);
		R0.H = _RTCHANDLER; 			// IVG7 Handler
		[ P0 ++ ] = R0;

	    R0 = _SportISR (Z);
		R0.H = _SportISR; 				// IVG8 Handler
	    [ P0 ++ ] = R0;

		R0 = _I9HANDLER (Z);
		R0.H = _I9HANDLER; 				// IVG9 Handler
	    [ P0 ++ ] = R0;

		R0 = _I10HANDLER (Z);
		R0.H = _I10HANDLER;				// IVG10 Handler
		[ P0 ++ ] = R0;

		R0 = _I11HANDLER (Z);
		R0.H = _I11HANDLER;				// IVG11 Handler
		[ P0 ++ ] = R0;

		R0 = _I12HANDLER (Z);
		R0.H = _I12HANDLER;				// IVG12 Handler
		[ P0 ++ ] = R0;

		R0 = _I13HANDLER (Z);
		R0.H = _I13HANDLER;				// IVG13 Handler
		[ P0 ++ ] = R0;

		R0 = _I14HANDLER (Z);
		R0.H = _I14HANDLER;				// IVG14 Handler
		[ P0 ++ ] = R0;

		R0 = _I15HANDLER (Z);
   		R0.H = _I15HANDLER;				// IVG15 Handler
		[ P0 ++ ] = R0;

		P0.L = EVT_OVERRIDE & 0xffff;  	// added in to address anomaly 20 for rev 0.1 ADSP-21535 silicon
		P0.H = EVT_OVERRIDE >> 16;
   		R0 = 0;
   		[ P0  ] = R0; ssync;

		SP.H = 0xF003;					// Set up supervisor stack
		SP.L = 0xFFDC;

		LoadP0(EVT15)					// Point to IVG15 in Event Vector Table	
		P1.L = Start;					//Point to start of  code	
		P1.H = Start;

		[P0] = P1; ssync;				// Place the address of start code in IVG15 of EVT

		P0.L = IMASK & 0xFFFF;
		R0 = W[P0];
		bitset(r0,15);					// Set(enable) IVG15 bit in Interrupt Mask Register
		W[P0] = R0; ssync;
		
		RAISE 15;						// Invoke IVG15 interrupt

		P0.l = WAIT_HERE;
		P0.h = WAIT_HERE;
		
		RETI = P0;
		nop;
		nop;
		nop;
		nop;
		RTI;							// Return from Reset Interrupt

WAIT_HERE:								// Wait here till IVG15 interrupt is processed
		JUMP WAIT_HERE;
		
// ---------------------------------------------------------------------------- 		
//	Main code starts here .....	
		
 Start:	[--SP] = RETI;					// RETI must be pushed to enable interrupts.  Boot code in supervisor mode starts here.
 
 		call	GeneralPurposeInit;
		call	Sport1Inits;
		call	SportIRQInits;
		call	Sport1TxDMASetup;
		call	Program73322s;
//		call	Sport1TxDMASetup2;		// Added (JWS)
		call	Sport1RxDMASetup;

		call	Recieve73322Data;
		
DieHere:
		nop;
		nop;
		nop;
		nop;
		jump	DieHere;
		
		
// ---------------------------------------------------------------------------- 		
//	Subs Start.....	
     
// init PFs and blink LEDs, reset CODEC
GeneralPurposeInit:
		// initalize pointer registers and data registers
		R0 = 0; R1 = 0; R2 = 0; R3 = 0; R4 = 0; R5 = 0; R6 = 0; R7 = 0;		
		P0 = 0; P1 = 0; P2 = 0; P3 = 0; P4 = 0; P5 = 0;		

		// initialize the DAG registers
		I0 = 0 (X); I1 = 0 (X); I2 = 0 (X); I3 = 0 (X);
		M0 = 0 (X); M1 = 0 (X); M2 = 0 (X); M3 = 0 (X);
		L0 = 0 (X); L1 = 0 (X); L2 = 0 (X); L3 = 0 (X);
		B0 = 0 (X); B1 = 0 (X); B2 = 0 (X); B3 = 0 (X);

		LoadP0(FIO_DIR)								// config PF I/O bits as outputs 											
		R0.l = w[P0];
		bitset (R0, Reset);
		bitset (R0, SE);
		bitset (R0, LED);
		w[P0] = R0.l; ssync;
		
		LoadP0(FIO_FLAG_S)							//  Set Init state for SE, Reset and LED == ON
		R0.l = 0x0C01;
		w[P0] = R0.l; ssync;
		
		P5.l = 0x0000;
		p5.h = 0x1000;
		loop blink_LEDs lc0=P5;
		loop_begin blink_LEDs;
		nop;
		loop_end blink_LEDs;
		
		LoadP0(FIO_FLAG_C)						// reset 73322, turn off LED
		r0.l = 0x0C01;
		w[P0] = R0.l; ssync;
		
		P5 = 0x00000140;						// hold reset for about 1uS
		loop hold_Reset lc0=P5;
		loop_begin hold_Reset;
		nop;
		loop_end hold_Reset;
		
		LoadP0(FIO_FLAG_S)						// release the Reset line, turn on LED
		r0.l = 0x0401;
		w[P0] = R0.l; ssync;
		
		p5.l = 0xd480;						// allow CODEC time to recouver from Reset
		P5.h = 0x3F00;
		loop ResetRecouver lc0=P5;
		loop_begin ResetRecouver;
		nop;
		loop_end ResetRecouver;
		rts;

		// ---------------------------------------------------------------------------- 		
				
Sport1Inits:
		R0 = 0x0000;
		
		LoadP0(SPORT1_TX_CONFIG)
		w[P0] = R0; ssync;

		LoadP0(SPORT1_RX_CONFIG)
		w[P0] = R0; ssync;
		
		LoadP0(SPORT1_CONFIG_DMA_TX)
		w[P0] = R0; ssync;

		LoadP0(SPORT1_CONFIG_DMA_RX)
		w[P0] = R0; ssync;

		LoadP0(SPORT1_MCMC1)
		w[P0] = R0; ssync;

		LoadP0(SPORT1_MCMC2)
		w[P0] = R0; ssync;
		
		LoadP0(SPORT1_IRQSTAT_RX)				// this clears any Rx errors
		R0.l = 0x07;
		w[P0] = R0; ssync;
		
		LoadP0(SPORT1_IRQSTAT_TX)				// this clears any Tx errors
		R0.l = 0x07;
		w[P0] = R0; ssync;

		R0.l = (TFSR + BITS16);
		LoadP0(SPORT1_TX_CONFIG)
		w[P0] = R0; ssync;

		R0.l = (RFSR + BITS16);
		LoadP0(SPORT1_RX_CONFIG)
		w[P0] = R0; ssync;

		rts;
		
		
		// ---------------------------------------------------------------------------- 
		
SportIRQInits:	
		R0.h = 0xFFFF;				// enables Sport1 IRQs, old =0x000000C0, Errata #8
		R0.l = 0xFF3F;
		LoadP0(SIC_IMASK)
		w[P0] = R0; ssync;
		
		R0.l = 0x011F;				// enables IVG8
		LoadP0(IMASK)
		w[P0] = R0; ssync;
		
		rts;		
		
		// ---------------------------------------------------------------------------- 
		
Program73322s:
		LoadP0(FIO_FLAG_C)					// clear SE (disable the CODEC)
		R0.l = 0;
		bitset (R0, SE);
		w[P0] = R0.l; ssync;
		
		R0.l = 0x0015;						// autobuffer, int on complete, DMA enabled
		LoadP0(SPORT1_CONFIG_DMA_TX)
		w[p0] = R0; ssync;

		LoadP0(SPORT1_TX_CONFIG)
		R0 = w[p0];
		Bitset(R0, TSPEN);					// enable Sport1
		w[p0] = R0; ssync;
		
		R7 = 0x0000;						// TX IRQ flag
		
		LoadP0 (FIO_FLAG_S)					// enable the CODEC: SE = 1
		R0 = w[P0];
		bitset (R0, SE);
		w[P0] = R0; ssync;
		
WaitOnTx:									// interrupt should be generated here !?!?!
		nop;
		nop;
		nop;
		nop;
		rts;
		
		// ---------------------------------------------------------------------------- 
		
Recieve73322Data:
		LoadP0(FIO_FLAG_C)					// clear SE (disable the CODEC)
		R0.l = 0;
		bitset (R0, SE);
		w[P0] = R0.l; ssync;
		
		R0.l = 0x0017;						// autobuffer, int on complete, DMA enabled
		LoadP0(SPORT1_CONFIG_DMA_RX)
		w[p0] = R0.l; ssync;

		
		
					
/*		R0.l = 0x0015;						// (JWS) autobuffer, int on complete, DMA enabled
		LoadP0(SPORT1_CONFIG_DMA_TX)
		w[p0] = R0; ssync;
		
		LoadP0(SPORT1_TX_CONFIG)
		R0 = w[p0];
		Bitset(R0, TSPEN);					// enable Sport1
		w[p0] = R0; ssync;	
			
		R7 = 0x0000;						// TX IRQ flag	
		
*/		
		
		
		
			
		LoadP0(SPORT1_RX_CONFIG)
		R0.l = w[p0];
		Bitset(R0, RSPEN);					// enable Sport1
		w[p0] = R0.l; ssync;
		
		LoadP0(FIO_FLAG_S)					// enable CODEC: SE = 1
		R0.l = w[P0];
		bitset (R0, SE);
		w[P0] = R0; ssync;
		
WaitOnRx:
		nop;								// interrupt should be generated here !?!?!
		nop;
		nop;
		nop;
		rts;

		// ---------------------------------------------------------------------------- 
		
Sport1TxDMASetup:		
		R0.l = 0x0014;						// enable autobuffer
									// DCOME set to 1 (interrupt on completion)
									
		LoadP0(SPORT1_CONFIG_DMA_TX)
		w[p0] = R0; ssync;

		R0.l = (TxBuf >> 16) & 0xFFFF;		// load start address HI word
		LoadP0(SPORT1_START_ADDR_HI_TX)
		w[p0] = R0; ssync;

		R0.l = TxBuf & 0xFFFF;				// load start address Lo word
		LoadP0(SPORT1_START_ADDR_LO_TX)	
		w[p0] = R0; ssync;

		R0.l = LENGTH (TxBuf);				// load length of buffer
		LoadP0(SPORT1_COUNT_TX)
		w[p0] = R0; ssync;
		rts;
		
		// ---------------------------------------------------------------------------- 
		
Sport1RxDMASetup:
		R0.l = 0x0014;					// DCOME set to 1
		LoadP0(SPORT1_CONFIG_DMA_RX)
		w[p0] = R0; ssync;

		R0.l = (RxBuf >> 16) & 0xFFFF;
		LoadP0(SPORT1_START_ADDR_HI_RX)
		w[p0] = R0; ssync;

		R0.l = RxBuf & 0xFFFF;
		LoadP0(SPORT1_START_ADDR_LO_RX)
		w[p0] = R0; ssync;

		R0.l = LENGTH (RxBuf);
		LoadP0(SPORT1_COUNT_RX)
		w[p0] = R0; ssync;
		rts;

		// ---------------------------------------------------------------------------- 
		
Sport1TxDMASetup2:
	
		R0.l = 0x0014;						// enable autobuffer
									// DCOME set to 1 (interrupt on completion)
									
		LoadP0(SPORT1_CONFIG_DMA_TX)
		w[p0] = R0; ssync;

		R0.l = (RxBuf >> 16) & 0xFFFF;		// load start address HI word
		LoadP0(SPORT1_START_ADDR_HI_TX)
		w[p0] = R0; ssync;

		R0.l = RxBuf & 0xFFFF;				// load start address Lo word
		LoadP0(SPORT1_START_ADDR_LO_TX)	
		w[p0] = R0; ssync;

		R0.l = LENGTH (RxBuf);				// load length of buffer
		LoadP0(SPORT1_COUNT_TX)
		w[p0] = R0; ssync;
		rts;
