// ----------------------------------------------------------------------------
// Buffers and CODEC initialization codes
// ----------------------------------------------------------------------------

#include <defines.h>

// ----------------------------------------------------------------------------
// Global and External definitions

.global	Done;
.global	Channel;

.global	CODEC_Init_Data;

.global	SineCos1;
.global	SineCos2;
.global	SineCos3;
.global	SineCos4;
.global	SineCos5;
.global	SineCos6;
.global	SineCos7;
.global	SineCos8;

.global	RxBufPointer;
.global	RxBuf1;
.global	RxBuf2;
.global	RxBuf3;
.global	RxBuf4;
.global	RxBuf5;
.global	RxBuf6;
.global	RxBuf7;
.global	RxBuf8;
.global	RxChannelEnables;

.global	TxBufPointer;
.global	TxBuf1;
.global	TxBuf2;
.global	TxBuf3;
.global	TxBuf4;
.global	TxBuf5;
.global	TxBuf6;
.global	TxBuf7;
.global	TxBuf8;
.global	TxChannelEnables;

// ----------------------------------------------------------------------------
// Data Memory

.Section Buffers;

// ----------------------------------------------------------------------------
// misc variables

.byte2	Done;	
.byte2	Channel;
.byte	RxChannelEnables[8];
.byte	TxChannelEnables[8];

// ----------------------------------------------------------------------------
// Actual Tx and Rx buffers and pointers

.byte2	RxBufPointer;
.byte2	RxBuf1[RxBufLength];
.byte2	RxBuf2[RxBufLength];
.byte2	RxBuf3[RxBufLength];
.byte2	RxBuf4[RxBufLength];
.byte2	RxBuf5[RxBufLength];
.byte2	RxBuf6[RxBufLength];
.byte2	RxBuf7[RxBufLength];
.byte2	RxBuf8[RxBufLength];

.byte2	TxBufPointer;
.byte2	TxBuf1[TxBufLength];
.byte2	TxBuf2[TxBufLength];
.byte2	TxBuf3[TxBufLength];
.byte2	TxBuf4[TxBufLength];
.byte2	TxBuf5[TxBufLength];
.byte2	TxBuf6[TxBufLength];
.byte2	TxBuf7[TxBufLength];
.byte2	TxBuf8[TxBufLength];

// ----------------------------------------------------------------------------
// CODEC initialization strings.
// to be copied into TxBuf1

.byte2	CODEC_Init_Data[CODEC_INIT_Length] =

//        5432109876543210 
		b#1000100100000111,			// CRB - DMCLK/256=64KHz=Fs, SCLK=DMCLK/4=4.096MHz, DMCLK=MCLK
		b#1000000100000111,			// CRB - DMCLK/256=64KHz=Fs, SCLK=DMCLK/4=4.096MHz, DMCLK=MCLK
		
//        5432109876543210 		
		b#1000101000111101,			// CRC - RefOut=Disabled, Ref Power=On,InAmp=Off, Gain Tap=Off
		b#1000001000111101,			// CRC - RefOut=Disabled, Ref Power=On,InAmp=Off, Gain Tap=Off
		
//        5432109876543210 		
		b#1000101100000000,			// CRD - I/O gain=0, ADC Mod=Off, Mute=Off
		b#1000001100000000,			// CRD - I/O gain=0, ADC Mod=Off, Mute=Off
		
//        5432109876543210 		
		b#1000110000000000,			// CRE - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		b#1000010000000000,			// CRE - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		
//        5432109876543210 		
		b#1000110100000000,			// CRF - A Gain Tap=0, Single Ended, A Gain Tap=Disables, 
		b#1000010000000000,			// CRF - Dac=0, InterpolatorBypass=Disabled, DGain tap=Disabled
		
//        5432109876543210 		
		b#1000111000000000,			// CRG - Digital Gain Tap Coef0-7=0
		b#1000011000000000,			// CRG - Digital Gain Tap Coef0-7=0
		
//        5432109876543210 		
		b#1000111100000000,			// CRH - Digital Gain Tap Coef8-15=0
		b#1000011100000000,			// CRH - Digital Gain Tap Coef8-15=0
		
//        5432109876543210 
		b#1000100000010000,			// CRA - Program Mode, Mixed Mode=Off, Dig/SPORT LoopBack=0, Device Count=1
		b#1000000000010000,			// CRA - Program Mode, Mixed Mode=Off, Dog/SPORT LoopBack=0, Device Count=1
		
//        5432109876543210 			
		b#1000100000010001,			// CRA - Data Mode, Mixed Mode=Off, LoopBack=0, Device Count=1
		b#1000000000010001;			// CRA - Data Mode, Mixed Mode=Off, LoopBack=0, Device Count=1
    
   

// ----------------------------------------------------------------------------
// Data to output to the CODECs ... Sine, Cos and 1, 2, 3 and 4 pulse trains

/* .byte2	SineCos1 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;
*/	
.byte2	SineCos2 [SineCosTableLength] =	
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;

.byte2	SineCos3 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;

.byte2	SineCos4 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;
	
.byte2	SineCos5 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;

.byte2	SineCos6 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;
	
.byte2	SineCos7 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;

.byte2	SineCos8 [SineCosTableLength] =
	0x8000,
	0x8000,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x7fff,
	0x7fff,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;

.byte2	SineCos1 [SineCosTableLength] =
	0x7FFF,
	0x7D8A,
	0x7641,
	0x6A6D,
	0x5A82,
	0x471C,
	0x30FB,
	0x18F8,
	0x0000,
	0xE707,
	0xCF04,
	0xB8E3,
	0xA57D,
	0x9592,
	0x89BE,
	0x8275,
	0x8000,
	0x8275,
	0x89BE,
	0x9592,
	0xA57D,
	0xB8E3,
	0xCF04,
	0xE707,
	0x0000,
	0x18F8,
	0x30FB,
	0x471C,
	0x5A82,
	0x6A6D,
	0x7641,
	0x7D8A;
/*	
.byte2	SineCos2 [SineCosTableLength] =	
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;

.byte2	SineCos3 [SineCosTableLength] =
	0x0000,
	0x18F8,
	0x30FB,
	0x471C,
	0x5A82,
	0x6A6D,
	0x7641,
	0x7D8A,
	0x7FFF,
	0x7D8A,
	0x7641,
	0x6A6D,
	0x5A82,
	0x471C,
	0x30FB,
	0x18F8,
	0xFFFF,
	0xE707,
	0xCF04,
	0xB8E3,
	0xA57D,
	0x9592,
	0x89BE,
	0x8275,
	0x8000,
	0x8275,
	0x89BE,
	0x9592,
	0xA57D,
	0xB8E3,
	0xCF04,
	0xE707;

.byte2	SineCos4 [SineCosTableLength] =
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;
	
.byte2	SineCos5 [SineCosTableLength] =
	0x7FFF,
	0x7D8A,
	0x7641,
	0x6A6D,
	0x5A82,
	0x471C,
	0x30FB,
	0x18F8,
	0x0000,
	0xE707,
	0xCF04,
	0xB8E3,
	0xA57D,
	0x9592,
	0x89BE,
	0x8275,
	0x8000,
	0x8275,
	0x89BE,
	0x9592,
	0xA57D,
	0xB8E3,
	0xCF04,
	0xE707,
	0x0000,
	0x18F8,
	0x30FB,
	0x471C,
	0x5A82,
	0x6A6D,
	0x7641,
	0x7D8A;

.byte2	SineCos6 [SineCosTableLength] =
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;
	
.byte2	SineCos7 [SineCosTableLength] =
	0x0000,
	0x18F8,
	0x30FB,
	0x471C,
	0x5A82,
	0x6A6D,
	0x7641,
	0x7D8A,
	0x7FFF,
	0x7D8A,
	0x7641,
	0x6A6D,
	0x5A82,
	0x471C,
	0x30FB,
	0x18F8,
	0xFFFF,
	0xE707,
	0xCF04,
	0xB8E3,
	0xA57D,
	0x9592,
	0x89BE,
	0x8275,
	0x8000,
	0x8275,
	0x89BE,
	0x9592,
	0xA57D,
	0xB8E3,
	0xCF04,
	0xE707;

.byte2	SineCos8 [SineCosTableLength] =
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x7FFF,
	0x7FFF,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000,
	0x0000;
*/	

