// ----------------------------------------------------------------------------
//
// Blackfin - 73322 Final test code
//
// Main code - 1 stereo CODEC
//
// 03/20/03
//
// ----------------------------------------------------------------------------

#include <def21535.h>
#include <defines.h>

// ----------------------------------------------------------------------------
// Global and External definitions

.extern	_EHandler;
.extern _RHandler;
.extern _NHandler;
.extern _XHandler;
.extern _HWHandler;
.extern _THandler;
.extern _RTCHandler;

.extern _Sport1ISR;
.extern	_CODEC_INIT_ISR;
.extern	CODEC_Init_Length;
.extern	CODEC_Init_Data;

.extern _I9Handler;
.extern _I10Handler;
.extern _I11Handler;
.extern _I12Handler;
.extern _I13Handler;
.extern _I14Handler;
.extern _I15Handler;

.extern	Done;
.extern	Channel;
.extern	TxChannelEnables;
.extern	TxBufPointer;
.extern	TxBuf1;
.extern	TxBuf2;
.extern	TxBuf3;
.extern	TxBuf4;
.extern	TxBuf5;
.extern	TxBuf6;
.extern	TxBuf7;
.extern	TxBuf8;

.extern	RxChannelEnables;
.extern	RxBufPointer;
.extern	RxBuf1;
.extern	RxBuf2;
.extern	RxBuf3;
.extern	RxBuf4;
.extern	RxBuf5;
.extern	RxBuf6;
.extern	RxBuf7;
.extern	RxBuf8;

.extern	SineCos1;
.extern	SineCos2;
.extern	SineCos3;
.extern	SineCos4;
.extern	SineCos5;
.extern	SineCos6;
.extern	SineCos7;
.extern	SineCos8;

// ----------------------------------------------------------------------------
// Code
// ----------------------------------------------------------------------------
// Code start .....

.Section ProgramCode;

// Setup Event vectors and handlers

Start:
	R0 = 0;
	LoaddP0 (EVT0)
	R1 = _EHandler (Z);							// Emulation Handler IVG 0
	R1.h = _EHandler;
	[P0++] = R1;

	R1 = _RHandler (Z);							// Reset Handler IVG 1
	R1.h = _RHandler;
	[P0++] = R1;

	R1 = _NHandler (Z);							// NMI Handler IVG 2
	R1.h = _NHandler;
	[P0++] = R1;

	R1 = _XHandler (Z);							// Exception Handler IVG 3
	R1.h = _XHandler;
	[P0++] = R1;

	[P0++] = R0;								// IVT4 is not used

	R1 = _HWHandler (Z);						// Hardware Error Handler IVG 5
	R1.h = _HWHandler;
	[P0++] = R1;

	R1 = _THandler (Z);							// Timer Handler IVG 6
	R1.h = _THandler;
	[P0++] = R1;

	R1 = _RTCHandler (Z);						// Handler IVG 7
	R1.h = _RTCHandler;
	[P0++] = R1;

	R1 = _CODEC_INIT_ISR (Z);					// Sport Handler IVG 8
	R1.h = _CODEC_INIT_ISR;
	[P0++] = R1;

	R1 = _I9Handler (Z);						// Handler IVG 9
	R1.h = _I9Handler;
	[P0++] = R1;

	R1 = _I10Handler (Z);						// Handler IVG 10
	R1.h = _I10Handler;
	[P0++] = R1;

	R1 = _I11Handler (Z);						// Handler IVG 11
	R1.h = _I11Handler;
	[P0++] = R1;

	R1 = _I12Handler (Z);						// Handler IVG 12
	R1.h = _I12Handler;
	[P0++] = R1;

	R1 = _I13Handler (Z);						// Handler IVG 13
	R1.h = _I13Handler;	
	[P0++] = R1;

	R1 = _I14Handler (Z);						// Handler IVG 14
	R1.h = _I14Handler;
	[P0++] = R1;

	R1 = _I15Handler (Z);						// Handler IVG 15
	R1.h = _I15Handler;
	[P0++] = R1;

	LoaddP0 (EVT_OVERRIDE)					// added in to address anomaly 20 for rev 0.1 silicon
	R0 = 0;
	[P0] = R0; ssync;

//	Loadd (sp, 0xF003FFDC)// set supervisor stack
	sp.l = 0xF003FFDC & 0xFFFF;
	sp.h = (0xF003FFDC >> 16) & 0xFFFF;

// ----------------------------------------------------------------------------
// the following code allows the Blackfin to stay in supervisor mode exclusively

	LoaddP0 (EVT15)							// set IVG15 to the start of real code
	LoadP1 (SStart)
	[P0] = P1; ssync;

	P0.l = IMASK & 0xFFFF;						// enable IVG 15
	R0.l = w[P0];
	bitset (R0, 15);
	w[P0] = R0.l; ssync;

	raise 15;									// invoke IVG interrupt

	LoadP0 (Wait_Here)
	
	reti = P0;
	nop;
	nop;
	nop;
	nop;
	rti;										// return from Reset Interrupt

Wait_Here:										// wait here till IVG15 interrupt is processed
	jump	Wait_Here;

// ----------------------------------------------------------------------------
// this is the real start of code...

SStart:
	[--SP] = RETI;								// RETI must be pushed to enable interrupts.
												// Boot code in supervisor mode starts here.
	// initalize pointer registers and data registers
	R0 = 0; R1 = 0; R2 = 0; R3 = 0; R4 = 0; R5 = 0; R6 = 0; R7 = 0;		
	P0 = 0; P1 = 0; P2 = 0; P3 = 0; P4 = 0; P5 = 0;		

	// initialize the DAG registers
	I0 = 0 (X); I1 = 0 (X); I2 = 0 (X); I3 = 0 (X);
	M0 = 0 (X); M1 = 0 (X); M2 = 0 (X); M3 = 0 (X);
	L0 = 0 (X); L1 = 0 (X); L2 = 0 (X); L3 = 0 (X);
	B0 = 0 (X); B1 = 0 (X); B2 = 0 (X); B3 = 0 (X);

// ----------------------------------------------------------------------------
// enable all of the Rx and Tx channels
	
	nop;
	nop;
		
	P1 = NoChannels;							// (JWS) old=8, new=2
	LoadP0 (TxChannelEnables)					// initialize the Tx Channel Enables to all ON
	R0 = 0x01;
	loop TxCELoop lc0 = P1;
	loop_begin TxCELoop;
	b[P0++] = R0;
	loop_end TxCELoop;

	LoadP0 (RxChannelEnables)					// initialize the Rx Channel Enables to all ON
	R0 = 0x01;
	loop RxCELoop lc0 = P1;
	loop_begin RxCELoop;
	b[P0++] = R0;
	loop_end RxCELoop;

// ----------------------------------------------------------------------------

	LoaddP0 (FIO_DIR)							// config PF I/O bits as outputs 											
	R0.l = w[P0];
	bitset (R0, Reset);
	bitset (R0, SE);
	bitset (R0, LED);
	w[P0] = R0.l; ssync;
		
	LoaddP0 (FIO_FLAG_S)						//  Set Init state for SE, Reset and LED == ON
	R0.l = 0x0C01;
	w[P0] = R0.l; ssync;
		
	LoaddP5 (0x10000000)						// wait xxxuS
	loop blink_LEDs lc0=P5;
	loop_begin blink_LEDs;
	nop;
	loop_end blink_LEDs;
		
	LoaddP0 (FIO_FLAG_C)						// reset 1885, turn off LED
	r0.l = 0x0C01;
	w[P0] = R0.l; ssync;
		
	LoaddP5 (0x00000140)						// hold reset for about 1uS
	loop hold_Reset lc0=P5;
	loop_begin hold_Reset;
	nop;
	loop_end hold_Reset;
		
	LoaddP0 (FIO_FLAG_S)						// release the Reset line, turn on LED
	r0.l = 0x0401;
	w[P0] = R0.l; ssync;
		
	LoaddP5 (0x3F00D480)						// allow CODEC time to recouver from Reset
	loop ResetRecouver lc0=P5;
	loop_begin ResetRecouver;
	nop;
	loop_end ResetRecouver;
	
	R0 = 0x0000;								// initialize Sport 1
	LoaddP0 (SPORT1_TX_CONFIG)
	w[P0] = R0.l; ssync;

	LoaddP0 (SPORT1_RX_CONFIG)
	w[P0] = R0.l; ssync;
		
	LoaddP0 (SPORT1_CONFIG_DMA_TX)
	w[P0] = R0.l; ssync;

	LoaddP0 (SPORT1_CONFIG_DMA_RX)
	w[P0] = R0.l; ssync;

	LoaddP0 (SPORT1_MCMC1)
	w[P0] = R0.l; ssync;

	LoaddP0 (SPORT1_MCMC2)
	w[P0] = R0.l; ssync;
		
	LoaddP0 (SPORT1_IRQSTAT_RX)				// this clears any Rx errors
	R0.l = 0x07;
	w[P0] = R0.l; ssync;
		
	LoaddP0 (SPORT1_IRQSTAT_TX)				// this clears any Tx errors
	R0.l = 0x07;
	w[P0] = R0.l; ssync;

	R0.l = (TFSR + BITS16);
	LoaddP0 (SPORT1_TX_CONFIG)
	w[P0] = R0.l; ssync;

	R0.l = (RFSR + BITS16);
	LoaddP0 (SPORT1_RX_CONFIG)
	w[P0] = R0; ssync;

	LoaddR0 (0xFFFFFF3F)						// enables Sport1 IRQs
	LoaddP0 (SIC_IMASK)
	w[P0] = R0.l; ssync;
	
	nop;										// this MUST be here !! CODEC init fails without it.
	nop;
	nop;
	
	LoaddP0 (FIO_FLAG_S)						// release the CODEC Reset line
	R0.l = 0x400;
	w[P0] = R0.l; ssync;

// ----------------------------------------------------------------------------
// Basic DSP is initilized and configured. Now do the CODEC
	
	Call Init_CODEC;
 	Call CODEC_Sync;

// ----------------------------------------------------------------------------
// CODEC is now up and running... load data into the output buffers
	LoadP0 (TxBufPointer)						// reset pointers
	R0.l = 0x00;
	w[P0] = R0.l;
	LoadP0 (RxBufPointer)						// reset pointers
	w[P0] = R0.l;
	
	LoadP0 (SineCos1)							// load each TxBuf with the SineCos tables
	LoadP1 (TxBuf1)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos2)
	LoadP1 (TxBuf2)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos3)
	LoadP1 (TxBuf3)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos4)
	LoadP1 (TxBuf4)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos5)
	LoadP1 (TxBuf5)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos6)
	LoadP1 (TxBuf6)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos7)
	LoadP1 (TxBuf7)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	LoadP0 (SineCos8)
	LoadP1 (TxBuf8)
	LoaddP2 (SineCosTableLength)
	call CopyMem;
	


// ----------------------------------------------------------------------------
// all done. let the interrupts do the work from here on.
	
stophere:
	jump	stophere;	
	
// ----------------------------------------------------------------------------
// Initialize the CODECs
	
Init_CODEC:
	LoadP0 (TxBufPointer)						// clear Tx buffer pointer
	R0 = 0;
	w[P0] = R0.l;
		
	LoadP1 (Done)								// clear flag
	R0 = 0x00;
	w[P1] = R0.l;
	
	LoaddP0 (SPORT1_TX_CONFIG)				// enable Sport1
	R0.l = w[P0];
	bitset (R0, TSPEN);
	w[P0] = R0.l; ssync;
	
	LoaddP0 (FIO_FLAG_S)						// release the CODEC SE line
	R0.l = 0x800;
 	w[P0] = R0.l; ssync;

	LoaddP0 (IMASK)							// enable interrupts
	R0.l = 0x11F;
	w[P0] = R0.l; ssync;

WaitForDone:	
	R0 = w[P1];									// wait for flag to show that the 
	cc = R0 == 0;								// CODEC has been initialized.
	if cc jump WaitForDone;

//	Loadd (P0, FIO_FLAG_C)						// put the CODEC to sleep via the SE line
//	R0 = 0x800;
// 	w[P0] = R0; ssync;
		
	LoadR0 (_Sport1ISR)						// restore the ISR to the main 
	LoaddP0 (EVT8)							// Sport ISR
	[P0] = R0;
	rts;
	
// ----------------------------------------------------------------------------
// Copys from one memory location to another
// P0 = Source
// P1 = Destination
// P2 = number of WORDs

CopyMem:
	lsetup (CopyStart, CopyEnd) lc0 = P2;	// setup loop to copy memory to memory
	
CopyStart:
	R0 = w[P0++];
	w[P1++] = R0;

CopyEnd:
	nop;									// this nop is required. A loop_end
	rts;									// can never end with rts (etc)
		
// ----------------------------------------------------------------------------
// Allow the DSP to determine when the start of a block of data 
// starts from the CODEC. ( I then know when to set Channel to 0)

CODEC_Sync:
	LoaddP0 (SPORT1_IRQSTAT_TX)			// clear interrupts
	R0.l = 0x01;
	w[P0] = R0; ssync;
	LoaddP0 (SPORT1_IRQSTAT_RX)
	R0.l = 0x07;
	w[P0] = R0; ssync;
	
	LoaddP0 (SPORT1_TX_CONFIG)			// enable Sport1 for Tx
	R0 = w[P0];
	bitset (R0, TSPEN);
	w[P0] = R0; ssync;

	LoaddP0 (SPORT1_RX_CONFIG)			// enable Sport1 for Rx
	R0 = w[P0];
	bitset (R0, RSPEN);
	w[P0] = R0; ssync;

	LoadP1 (Done)							// Load the address of the flag.

SyncLoop:
	R0 = 0x00;								// clear the flag
	w[P1] = R0;
	
	LoaddP0 (0x0320)						// wait for 1.5 Frame Syncs
	loop FS15 lc0 = P0;
	loop_begin FS15;
	nop;
	loop_end FS15;
	
	R0 = w[P1];								// test the flag
	cc = R0 == 0x00;
	if !cc jump SyncLoop;					// if set, an interrupt occured
		
	LoadP0 (Channel)						// no interrupt occured, thus I am between samples
	R0 = 0x00;								// and the next sample will be channel 0
	w[P0] = R0;
	rts;
	
